// CELLARRA.H

/*****************************************************************
These source files represent significant changes to the original
WorldCom MFC library.  Therefore, these source files may not be
copied except by permission of the author, Joe Willcoxson.  These
source files may not be included in source or compiled form as any
part of a commercial distribution except by permission of the
author.  These files may be used freely for internal corporate use
such as software produced by an IS departement.  These files may
also may be used freely by students for educational purposes.

No warranty or guarrantee of fitness can be made to these files.
*****************************************************************/

#ifndef cellarray_h
#define cellarray_h


// CCellArray is a class to manage cell arrays for cells which you put 
// into a CCellGrid cell.  It is owned by a CCellMatrix

class CCell;

class  CCellArray
{
  	public:
  	 CCellArray( int cellcount = 0);
  	 ~CCellArray();
  	
  	void  SetCell(int index, CCell* aCell); // deletes old cell
  	const CCell*  GetCell(int index);
  	
  	void  DeleteAt(int index);
  	void  InsertAt(int index, CCell* aCell);
  	
  	void  Add(CCell* aCell);
  	
  	protected:
  	
  	CPtrArray m_Cells;
  	
};

#endif

// Copyright (c) 1997 by Joe Willcoxson and WorldCom.  All rights reserved.
// E-mail:  chinajoe@aol.com
// URL:  http://users.aol.com/chinajoe
// For great long distance service see http://www.wcom.com

